package inf112.skeleton.app.model;

import inf112.skeleton.app.Controller.IGameObject;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;

public class NPC implements IGameObject{
    int x, y, w, h, drawW;
    Image i1, i2, i3, i4, i5, i6;
    Image image;
    private int gravity = 5;
    public int runCounter = 0;
    public boolean canMoveDown = true;
    public boolean interactable;
    public int direction = -1;

    public NPC(int X, int Y) {
        GetNPCImage();
        this.x = X;
        this.y = Y;
        this.w = 120;
        this.h = 100;
        this.drawW = 70;
    }

    @Override
    public int getHeight() {
        return this.h;
    }

    @Override
    public int getWidth() {
        return this.w;
    }

    @Override
    public int getX() {
        return this.x;
    }

    @Override
    public int getY() {
        return this.y;
    }

    @Override
    public int getSpeed() {
        return 0;
    }

    @Override
    public int getGravity() {
        return this.gravity;
    }

    public void idle() {
        if (canMoveDown) {
            this.y += gravity;
        }
    }

    public void GetNPCImage() {
        this.i1 = new Image("file:src/Images/NPC/idle1.png");
        this.i2 = new Image("file:src/Images/NPC/idle2.png");
        this.i3 = new Image("file:src/Images/NPC/idle3.png");
        this.i4 = new Image("file:src/Images/NPC/idle4.png");
        this.i5 = new Image("file:src/Images/NPC/idle5.png");
        this.i6 = new Image("file:src/Images/NPC/idle6.png");
    }

    public void drawNPC(GraphicsContext gc, Player player) {
        if (runCounter > 50) {
            runCounter = 0;
        }

        //draw idle
        switch (runCounter) {
            case 0 -> this.image = i1;
            case 10 -> this.image = i2;
            case 20 -> this.image = i3;
            case 30 -> this.image = i4;
            case 40 -> this.image = i5;
            case 50 -> this.image = i6;
        }
        runCounter += 1;

        int npc_w = this.drawW;
        int npc_h = this.h;

        double npc_xPos = (this.x - npc_w*direction / 2.0) - direction - player.getX() + player.screenX;
        double npc_yPos = (this.y - npc_h / 2.0);

        //hitbox
        //gc.fillRect((this.x - w/2.0) - player.getX() + player.screenX, y - h/2.0, w, h);


        gc.drawImage(image, npc_xPos, npc_yPos, npc_w*direction, npc_h);
    }

    public void drawNPCDialogue(GraphicsContext gc, double w, double h) {
        int width = 400;
        int height = 200;
        double x = w/2 - width/2;
        double y = h/3.5 - height/2;

        gc.setFill(Color.rgb(0, 0, 0, 0.8));
        gc.fillRoundRect(x, y, width, height, 35, 35);

        gc.setFill(Color.WHITE);
        gc.setFont(new Font("Comic sans MS", 20));
        gc.fillText("Who goes there! Oh greetings,\n young traveler. I have heard\n a rumor that there is " +
                "a mighty fine\ntreasure for the one who dear cross\n the forbidden lands.", x + 20, y + 50);
        gc.restore();
    }

}
