package inf112.skeleton.app.model;

import inf112.skeleton.app.Controller.IGameObject;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;

public class Platform implements IGameObject{
    private int x, y, w, h;
    String type;
    private Image platformGrass;
    private Image box;
    

    public Platform(int X, int Y, int W, int H, String type) {
        this.x = X;
        this.y = Y;
        this.w = W;
        this.h = H;
        this.type = type;
        this.platformGrass = new Image("file:src/Images/Objects/grassplatform.png");
        this.box = new Image("file:src/Images/Objects/box.png");
    }
    
    /**
     * 	Use ONLY for testing!
     *  Test does not run if we create a new instance of Image in the constructor.
     * @param X Coordinate
     * @param Y Coordinate
     * @param W Width
     * @param H height
     */
    public Platform(int X, int Y, int W, int H) {
        this.x = X;
        this.y = Y;
        this.w = W;
        this.h = H;
        this.type = "";
    }

    public int getHeight() {
        return this.h;
    }

    public int getWidth() {
        return this.w;
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    @Override
    public int getSpeed() {
        return 0;
    }

    @Override
    public int getGravity() {
        return 0;
    }

    public void drawWall(GraphicsContext gc, Player player) {
        int walls_w = this.w;
        int walls_h = this.h;

        double walls_xPos = (this.x - walls_w / 2.0) - player.getX() + player.screenX;
        double walls_yPos = (this.y - walls_h / 2.0);

        if (this.type == "grass") {
            gc.drawImage(platformGrass, walls_xPos, walls_yPos, walls_w, walls_h);
        }
        else if (this.type == "box") {
            gc.drawImage(box, walls_xPos, walls_yPos, walls_w, walls_h);
        }
    }
    

}
